UVALive 2035 The Monocycle(BFS状态处理+优先队列)

  这道题目真是非常坎坷啊,WA了很多次,但所有的思路都是奔着广搜去想的,一开始出现了比答案大的数据,才想到了应该是优先队列,再说加上也肯定不会错。一开始我读错了题意,以为旋转并且前行需要的时间跟其他一样,但是旋转的动作是需要额外计时的。我的第一种方法错误原因还没有找到,我在旋转以后就直接改动了位置,感觉没有什么本质区别,旋转了以后,肯定要走啊,我直接加上时间也没什么问题,我也把所能想到的测试用例都试过了,与AC代码完全一致,真是搞不懂,这要是CF就好了。于是,学习了别人的代码,改了改我原先的地方,发现还真是那里错了。。又经过了一番钻研,才算优雅的AC了题目。

  吐槽就到这里了,我来说一下代码吧。

  状态使用四维数组保存,位置占两维,方向和颜色各占一维,颜色就是题目中给的5种颜色,方向最好给定一个标号,便于以后的行走。(0N ,1E, 2S,3W) ,在搜索过程中,每一次操作都将会耗费1秒种,操作分为向左右旋转,即改变dir,向目前的方向移动,改变x和y。 每次都让这3中新的状态进入优先队列,选择耗费时间小的作为队头,这样当搜索到的时候,便是耗费最小的步数。

#include<iostream>
#include<cstdio>
#include<map>
#include<queue>
#include<cstring>
using namespace std;
#define maxn 30
struct Node{
    int x,y,col,dir,tim;
    bool operator < (Node a)const{
        return a.tim < tim;
    }
};
char maps[maxn][maxn];
int state[maxn][maxn][10][10],n,m,go[4][2]={{-1,0},{0,1},{1,0},{0,-1}};///注意按照自己规定的方向处理数组,便于行走
priority_queue<Node> que;
bool ok(Node a){
    if(a.x>=0&&a.x<n && a.y>=0&&a.y<m && state[a.x][a.y][a.col][a.dir]==0 && maps[a.x][a.y]!=‘#‘) return true;
    return false;
}
void mark(Node a){
    state[a.x][a.y][a.col][a.dir] = 1;
}
int BFS(Node s){
    while(!que.empty()) que.pop();
    que.push(s);
    state[s.x][s.y][s.col][s.dir] = 1;
    while(!que.empty()){
        Node now = que.top();
        que.pop();
        if(maps[now.x][now.y]== ‘T‘ && now.col==0) return now.tim;
        Node nxt = now;
        nxt.tim++;///每一次操作,耗费1s
        nxt.dir = (now.dir + 1)%4;
        if(ok(nxt)){que.push(nxt); mark(nxt);}
        ///第一种向右转,注意是转

        nxt.dir = now.dir - 1; if(nxt.dir<0) nxt.dir=3;
        if(ok(nxt)){que.push(nxt); mark(nxt);}
        ///第二种向左转

        nxt.dir = now.dir;
        nxt.col=(now.col+1)%5;
        nxt.x = go[now.dir][0] + now.x;
        nxt.y = go[now.dir][1] + now.y;
        ///向所在方向行走,并且改变颜色
        if(ok(nxt)) {que.push(nxt); mark(nxt);}
    }
    return -1;
}
int main()
{
    int ca = 0;
    while(EOF != scanf("%d%d",&n,&m)){
        if(n==0&& m==0) break;
        if(ca) printf("\n"); ///注意不要多输出空行
        for(int i = 0;i < n;i++)
            scanf("%s",maps[i]);
        Node start;
        memset(state,0,sizeof(state));
        for(int i = 0;i < n;i++){
            for(int j = 0;j < m;j++){
                if(maps[i][j]==‘S‘){
                    start.x = i; start.y = j;
                    start.col=0;  start.dir=0;
                    start.tim = 0;
                }
            }
        }
        int ans = BFS(start);
        printf("Case #%d\n",++ca);
        if(ans == -1) printf("destination not reachable\n");
        else printf("minimum time = %d sec\n",ans);
    }
    return 0;
}
时间: 2024-10-11 20:35:47

UVALive 2035 The Monocycle(BFS状态处理+优先队列)的相关文章

uva 10047 uva live 2035 The Monocycle bfs

// uva 10047 uva live 2035 bfs // 求最短的嘛,肯定先尝试bfs啦 // 确定状态,首先状态里面得有坐标x,y // 还得有朝向,还得有颜色值 // // 这样就是一个状态里面有着三种属性 // 每个状态都只要经历一次,再经历是没有任何意义的 // 用一个que的思维数组记录就行了. // 按照方向爆搜,我先用f[i][j]记录的就是到 // 这一点的最小距离,但是怎么都过不了样例 // 突然明白了,如果只是这样记录最短距离,是不行的 // 因为每次从队列中取出的

hdoj 5094 Maze 【BFS + 状态压缩】 【好多坑】

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others) Total Submission(s): 901    Accepted Submission(s): 314 Problem Description This story happened on the background of Star Trek. Spock, the deputy captain of St

NYOJ 284 坦克大战 【BFS】+【优先队列】

坦克大战 时间限制:1000 ms  |  内存限制:65535 KB 难度:3 描述 Many of us had played the game "Battle city" in our childhood, and some people (like me) even often play it on computer now. What we are discussing is a simple edition of this game. Given a map that co

hdu--1429--胜利大逃亡(续) (bfs+状态压缩)

胜利大逃亡(续) Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8560    Accepted Submission(s): 3071 Problem Description Ignatius再次被魔王抓走了(搞不懂他咋这么讨魔王喜欢)-- 这次魔王汲取了上次的教训,把Ignatius关在一个n*m的地牢里,并在地牢的某些地方安装了带

ACM/ICPC 之 BFS+状态压缩(POJ1324(ZOJ1361))

求一条蛇到(1,1)的最短路长,题目不简单,状态较多,需要考虑状态压缩,ZOJ的数据似乎比POj弱一些 POJ1324(ZOJ1361)-Holedox Moving 题意:一条已知初始状态的蛇,求其到(1,1)的最短路长 题解:开始做的时候用BFS暴力做了一次,结果RE了,后来看了其他的题解和discuss才转向状态压缩.也看到有人用A*做出来了. 现在简要介绍一下状态压缩的思路: 由于蛇身最长只有8,可以利用两条相邻蛇身坐标确定其相对方向(四个方向),两位二进制可以表示 这样 一个蛇头坐标+

hdu2209翻纸牌游戏(bfs+状态压缩)

Problem Description 有一种纸牌游戏,很有意思,给你N张纸牌,一字排开,纸牌有正反两面,开始的纸牌可能是一种乱的状态(有些朝正,有些朝反),现在你需要整理这些纸牌.但是麻烦的是,每当你翻一张纸牌(由正翻到反,或者有反翻到正)时,他左右两张纸牌(最左边和最右边的纸牌,只会影响附近一张)也必须跟着翻动,现在给你一个乱的状态,问你能否把他们整理好,使得每张纸牌都正面朝上,如果可以,最少需要多少次操作. Input 有多个case,每个case输入一行01符号串(长度不超过20),1表

poj 1753 Flip Game(bfs状态压缩 或 dfs枚举)

Description Flip game is played on a rectangular 4x4 field with two-sided pieces placed on each of its 16 squares. One side of each piece is white and the other one is black and each piece is lying either it's black or white side up. Each round you f

hdu 4856 Tunnels(bfs+状态压缩)

题目链接:hdu 4856 Tunnels 题目大意:给定一张图,图上有M个管道,管道给定入口和出口,单向,现在有人想要体验下这M个管道,问最短需要移动的距离,起点未定. 解题思路:首先用bfs处理出两两管道之间移动的距离,然后后用状态压缩求出最短代价,dp[i][j],i表示的已经走过的管道,j是当前所在的管道. #include <cstdio> #include <cstring> #include <queue> #include <algorithm&g

hdu 1242:Rescue(BFS广搜 + 优先队列)

Rescue Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 14   Accepted Submission(s) : 7 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description Angel was caught by the MOLIGPY